<script lang="ts">
import { FactoryState, Order } from '@/model';
import { httpGet, httpPost } from '@/utils/connection';
import { defineComponent, reactive, Ref, ref } from '@vue/composition-api'
import { io, Socket } from 'socket.io-client';
import { useState } from 'vuex-composition-helpers';
import OrderSummary from './OrderSummary.vue'

export default defineComponent({
	components: { OrderSummary },
	name: "OrderQueue",
	setup() {
		let host = process.env.VUE_APP_API_URL ?? "";

		let orders = ref([] as Order[]);
		httpGet(`${host}/allorders`).then((res) => {
			if (res) orders.value = res.orders;
		});

		let socket = useState(["socket"]).socket as Ref<Socket>;
		socket.value.on("new-order", function (msg: Order) {
			// if(orders.value.some((o) => o.value.id == msg.id))	
			orders.value.unshift(msg);
		})

		async function queueOrder(id: string) {
			await httpPost(`${host}/nats/queueorder`, { id });
		}

		let state = useState(["assemblyLineState"]).assemblyLineState as Ref<FactoryState>

		return {
			orders,
			state,
			queueOrder
		}
	},
})
</script>

<template>
	<div class="order-queue">
		<div class="header">
			<div class="text-button">
				<v-icon>mdi-format-list-checkbox</v-icon>
				Orders
			</div>
		</div>
		<v-divider></v-divider>
		<div class="scroll-container">
			<div class="summaries">
				<order-summary
					v-for="order of orders" :key="order.id"  :order="order"
					class="summary"
					showQueueButton :disabled="state.activeOrders.some(x => x.id == order.id) || state.finishedOrders.some(x => x.id === order.id)"
					@queue-order="queueOrder">
				</order-summary>
			</div>
		</div>
	</div>
</template>

<style scoped>
.order-queue {
	display: flex;
	flex-direction: column;
	
	height: 100%;
}
.header {
	padding: .5em 1em;
}
.scroll-container {
	width: 100%;
	height: 100%;
	overflow: auto;
}
.summaries {
	display: flex;
	flex-direction: column;
	min-width: max-content;
	max-width: 1000px;
	gap: 10px;
	margin: 0 auto;
	padding: 10px;
}
.summary {
	padding: 10px;
	width: 100%;
}
</style>
